/* Code inspired of https://learn.sparkfun.com/tutorials/using-the-bluesmirf/example-code-using-command-mode
 */
#include <SoftwareSerial.h>  //include library for UART communication

int bluetoothTx = 2;  // TX pin of HC-08 Bluetooth Module, Arduino D2
int bluetoothRx = 3;  // RX pin of HC-08 Bluetooth Module, Arduino D3

//create an instance of a SoftwareSerial object
SoftwareSerial bluetooth(bluetoothTx, bluetoothRx); 

void setup()
{
  Serial.begin(9600);  // Begin the serial monitor at 9600bps
  bluetooth.begin(9600);  // Begin The Bluetooth Module, default is 9600bps
  bluetooth.print("AT");  // Test command
  delay(100);  // Short delay, wait for the Module to send back OK
  bluetooth.print("AT+RX"); // Check the basic parameters
  delay(100);
  bluetooth.print("AT+NAME=HC-MrMaster"); // Change name on the module
  delay(100);
  bluetooth.print("AT+ROLE=M"); // Change role from slave to master
  delay(100);
  bluetooth.print("AT+CONT=0"); // Set connect ability so it can be connected, default is 0
  delay(100);
  bluetooth.print("AT+BIND=F8,33,31,A9,CB,D4"); // Binding to slave for secure and automatic connection   
  delay(100);
  bluetooth.print("AT+RX"); // Check new basic parameters
}

void loop()
{
  if(bluetooth.available())  // If the bluetooth sent any characters
  {
    // Send any characters the bluetooth prints to the serial monitor
    Serial.print((char)bluetooth.read());  
  }
  if(Serial.available())  // If anything is typed into the Serial monitor
  {
    // Send any characters the Serial monitor prints to the bluetooth
    bluetooth.print((char)Serial.read());
  }
}
