/*  This code is written with inspiration from 
 *  Dejan Nedelkovski, www.HowToMechatronics.com 
 *  and xn1ch1, 
 *  https://www.instructables.com/Arduino-Dual-Function-Button-Long-PressShort-Press/
 *                 == Controller code ==
 */
#include <SoftwareSerial.h>
int bluetoothTx = 1; // TX pin of HC-08 Bluetooth Module, Arduino D1
int bluetoothRx = 0; // RX pin of HC-08 Bluetooth Module, Arduino D0,
// Rx is not needed since communication is only going one way

//create an instance of a SoftwareSerial object
SoftwareSerial BTserial(bluetoothRx, bluetoothTx); //Rx,Tx
#define led 4       // the number of the led pin
#define button 6     // the number of the pushbutton pin

boolean buttonState = false; // variable for storing last status of the pushbutton
boolean longPressActive = false; // variable for long press 
long buttonTimer = 0; // variable for time tracking
long longPressTime = 500; // Time of a long press i milliseconds

void setup(){
  pinMode(button, INPUT); // Configure the button pin as an input
  pinMode(led, OUTPUT);   // Configure the led pin as an output
  Serial.begin(9600);    //Default communication rate of the Bluetooth module
  BTserial.begin(9600); // Begin The Bluetooth Module, defau
  lt is 9600bps
}

void loop(){
  digitalWrite(led, HIGH); // Led turns on when the controller turns on
  if (digitalRead(button) == HIGH) { // The button is pressed
    if (buttonState == false) { // Detect if buttonState has changed since the last iteration
      buttonState = true; // A buttonpress is detected
      buttonTimer = millis(); // Record the time of the buttonpress in milliseconds 
    }
    // Check if current time subtracted from the time of the first buttonpress is longer than time for a long press, and if long press have been avtivated since last iteration
    if ((millis() - buttonTimer > longPressTime) && (longPressActive == false)) {
      longPressActive = true; // variable changed to true to stop repeated activation of long press
      Serial.print(BTserial.write('2')); // Send long press signal to BADDY
    }
  } else { // Button is not pressed anymore    
    if (buttonState == true) { // The button has been pressed
      if (longPressActive == true) { // Checking if a long press was activated
        longPressActive = false; // Changed to false to allow new long press next iteration
      } else { // Long press was not activated
        Serial.print(BTserial.write('1')); // Send short press signal to BADDY
      }
      buttonState = false; //Changed to allow new press in next iteration
    }
  }
  delay(50);  
}
